VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   1875
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   4095
   LinkTopic       =   "Form1"
   ScaleHeight     =   1875
   ScaleWidth      =   4095
   StartUpPosition =   3  'Windows Default
   Begin VB.Label lblSelected 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   2040
      TabIndex        =   2
      Top             =   1440
      Width           =   495
   End
   Begin VB.Label Label2 
      Caption         =   "Selected"
      Height          =   255
      Left            =   1320
      TabIndex        =   1
      Top             =   1440
      Width           =   735
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Right-click here to present the popup menu"
      BeginProperty Font 
         Name            =   "Times New Roman"
         Size            =   15.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   855
      Left            =   480
      TabIndex        =   0
      Top             =   360
      Width           =   3135
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuState 
      Caption         =   "&State"
      Begin VB.Menu mnuStateEntry 
         Caption         =   "State Entry"
         Index           =   0
      End
   End
   Begin VB.Menu mnuPopup 
      Caption         =   ""
      Enabled         =   0   'False
      Visible         =   0   'False
      Begin VB.Menu mnuPopupEntry 
         Caption         =   "Popup Entry"
         Index           =   0
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function GetMenu Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function GetSubMenu Lib "user32" (ByVal hMenu As Long, ByVal nPos As Long) As Long
Private Declare Function GetMenuItemCount Lib "user32" (ByVal hMenu As Long) As Long
Private Declare Function GetMenuString Lib "user32" Alias "GetMenuStringA" (ByVal hMenu As Long, ByVal wIDItem As Long, ByVal lpString As String, ByVal nMaxCount As Long, ByVal wFlag As Long) As Long
Private Declare Function GetMenuItemID Lib "user32" (ByVal hMenu As Long, ByVal nPos As Long) As Long
Private Declare Function ModifyMenu Lib "user32" Alias "ModifyMenuA" (ByVal hMenu As Long, ByVal nPosition As Long, ByVal wFlags As Long, ByVal wIDNewItem As Long, ByVal lpString As Any) As Long
Private Const MF_BYPOSITION = &H400&
Private Const MF_MENUBREAK = &H40&
' Insert columns in this menu so it has at
' most items_per_column items in each column.
Private Sub InsertColumns(ByVal h_menu As Long, ByVal items_per_column As Integer)
Dim num_items As Long
Dim i As Integer
Dim item_id As Long
Dim item_name As String
Dim item_length As Long

    ' See how many items are in the menu.
    num_items = GetMenuItemCount(h_menu)

    For i = items_per_column + 1 To num_items Step items_per_column
        ' Get this entry's name.
        item_name = Space$(256)
        item_length = GetMenuString(h_menu, _
            i - 1, item_name, Len(item_name), _
            MF_BYPOSITION)
            item_name = Left$(item_name, item_length)

        ' Get the item's ID.
        item_id = GetMenuItemID(h_menu, i - 1)

        ' Make this entry begin a column.
        ModifyMenu h_menu, i - 1, _
            MF_BYPOSITION + MF_MENUBREAK, _
            item_id, item_name
    Next i
End Sub
' Make the state popup aand menu entries.
Private Sub MakeStateEntries()
Dim menu_name As Collection
Dim i As Integer

    ' Create the list of states.
    Set menu_name = New Collection
    menu_name.Add "AK"
    menu_name.Add "AL"
    menu_name.Add "AR"
    menu_name.Add "AZ"
    menu_name.Add "CA"
    menu_name.Add "CO"
    menu_name.Add "CT"
    menu_name.Add "DC"
    menu_name.Add "DE"
    menu_name.Add "FL"
    menu_name.Add "GA"
    menu_name.Add "HI"
    menu_name.Add "IA"
    menu_name.Add "ID"
    menu_name.Add "IL"
    menu_name.Add "IN"
    menu_name.Add "KS"
    menu_name.Add "KY"
    menu_name.Add "LA"
    menu_name.Add "MA"
    menu_name.Add "MD"
    menu_name.Add "ME"
    menu_name.Add "MI"
    menu_name.Add "MN"
    menu_name.Add "MO"
    menu_name.Add "MS"
    menu_name.Add "MT"
    menu_name.Add "NC"
    menu_name.Add "ND"
    menu_name.Add "NE"
    menu_name.Add "NH"
    menu_name.Add "NJ"
    menu_name.Add "NM"
    menu_name.Add "NV"
    menu_name.Add "NY"
    menu_name.Add "OH"
    menu_name.Add "OK"
    menu_name.Add "OR"
    menu_name.Add "PE"
    menu_name.Add "RI"
    menu_name.Add "SC"
    menu_name.Add "SD"
    menu_name.Add "TN"
    menu_name.Add "TX"
    menu_name.Add "UT"
    menu_name.Add "VA"
    menu_name.Add "VT"
    menu_name.Add "WA"
    menu_name.Add "WI"
    menu_name.Add "WV"
    menu_name.Add "WY"

    ' Create the menu and popup menu entries.
    For i = 1 To menu_name.Count
        ' The first entry was created at
        ' design time. Load the other entries.
        If i > 1 Then
            Load mnuPopupEntry(i - 1)
            Load mnuStateEntry(i - 1)
        End If
        mnuPopupEntry(i - 1).Caption = menu_name(i)
        mnuStateEntry(i - 1).Caption = menu_name(i)
    Next i
End Sub
' Create menu entries.
Private Sub Form_Load()
Dim h_menu As Long
Dim h_submenu As Long

    ' Create the state popup and menu entries.
    MakeStateEntries

    ' Get the main menu handle.
    h_menu = GetMenu(Me.hwnd)

    ' -----------
    ' States menu
    ' -----------
    ' Get the State menu's handle.
    h_submenu = GetSubMenu(h_menu, 1)

    ' Make 10 entry columns in the State menu.
    InsertColumns h_submenu, 10
End Sub

Private Sub Label1_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim h_menu As Long
Dim h_submenu As Long

    If Button = vbRightButton Then
        ' Before displaying the popup menu,
        ' make it visible and give it columns.
        mnuPopup.Visible = True

        ' Get the main menu handle.
        h_menu = GetMenu(Me.hwnd)
    
        ' ----------
        ' Popup menu
        ' ----------
        ' Get the popup menu's handle.
        h_submenu = GetSubMenu(h_menu, 2)
    
        ' Make 10 entry columns in the popup menu.
        InsertColumns h_submenu, 10
        
        ' Display the popup menu.
        PopupMenu mnuPopup

        ' Hide the menu in the menu bar again.
        mnuPopup.Visible = False
    End If
End Sub
Private Sub mnuFileExit_Click()
    Unload Me
End Sub

Private Sub mnuPopupEntry_Click(Index As Integer)
    lblSelected.Caption = mnuPopupEntry(Index).Caption
End Sub

Private Sub mnuStateEntry_Click(Index As Integer)
    lblSelected.Caption = mnuStateEntry(Index).Caption
End Sub


